mysite/mysite/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('simula_ai.urls')),
    
]

mysite/simula_ai/urls.py
from django.urls import path
from . import views
from django.views.generic import TemplateView

app_name = 'simula_ai'
urlpatterns = [
    path('', views.index, name='index'),
    path('detalhes/<int:pk>/', views.detalhes.as_view(), name='detalhes'),
    path('resultado', views.resultado, name='resultado'),

]

mysite/simula_ai/models.py
from django.db import models
from django.contrib.auth.models import User
from django.db import models

# Create your models here.

class UserProfile(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE)
    # other fields here

    def __str__(self):
        return self.user.username

class Rotulo(models.Model):
    titulo = models.CharField('título', max_length = 30)
    class Meta:
        verbose_name = 'Rótulo'
    def __str__(self):
        return self.titulo

class Pergunta(models.Model):
    texto = models.CharField(max_length = 100)
    rotulos = models.ManyToManyField(Rotulo, blank=True)
    possui_resposta = models.BooleanField(default=False)
    
    #**** retorna o estado da instância na forma de texto
    def __str__(self):
        return ("{0} - {1}").format(self.id, self.texto)


class Alternativa(models.Model):
    texto = models.CharField(max_length = 50)
    pergunta = models.ForeignKey(
        Pergunta, on_delete = models.CASCADE
    )
    correta = models.BooleanField(default=False)
    #**** retorna o estado da instância na forma de texto
    def __str__(self):
        return ("{0} - {1}").format(self.pergunta.texto, self.texto)
    
class Resposta(models.Model):
    user = models.ForeignKey(User, on_delete=models.SET_NULL, null=True)
    alternativa = models.ForeignKey(Alternativa, on_delete=models.CASCADE)

class Simulado(models.Model):
    titulo = models.CharField(max_length = 30)
    perguntas = models.ManyToManyField(Pergunta)
    alternativas = models.ForeignKey(Alternativa, on_delete=models.CASCADE)
    class Meta:
        verbose_name = 'Simulado'
    def __str__(self):
        return self.titulo

mysite/simula_ai/views.py
from django.shortcuts import render, get_object_or_404
from django.http import HttpResponse, HttpResponseRedirect
from django.urls import reverse
from django.template import loader
from django.views.decorators.csrf import csrf_exempt
import simula_ai
from .models import Pergunta, Alternativa, Rotulo, Simulado, Resposta
from django.views import View
# Create your views here.


def index(request):
    simulados = Simulado.objects.all()
    template = loader.get_template('simula_ai/index.html')
    context = {'simulados': simulados}
    return HttpResponse(template.render(context, request))

class detalhes(View):
    def get(self, request, pk):
        simulado = get_object_or_404(Simulado, pk=pk)
        perguntas = simulado.perguntas.all()
        alternativas = Alternativa.objects.filter(pergunta__in=perguntas)
        context = {'perguntas': perguntas, 'simulado': simulado, 'alternativas': alternativas}
        return render(request, 'simula_ai/detalhes.html',context )

    def post(self, request, pk):
        simulado = get_object_or_404(Simulado, pk=pk)
        perguntas = simulado.perguntas.all()
        alternativas = Alternativa.objects.filter(pergunta__in=perguntas)
        respostas = Resposta.objects.filter(simulado=simulado)
        context = {'perguntas': perguntas, 'simulado': simulado, 'alternativas': alternativas, 'respostas': respostas}
        return render(request, 'simula_ai/resultado.html', context)
@csrf_exempt
class resultado (View):
    def get(self, request, pk):
        pergunta = get_object_or_404(Pergunta, pk=pk)
        alternativas = pergunta.alternativa_set.all()
        context = {'pergunta': pergunta, 'alternativas': alternativas}
        return render(request, 'simula_ai/resultado.html', context)

mysite/simula_ai/templates/simula_ai/detalhes.html
<!DOCTYPE html>
{% load static %}

<html lang="pt-br">
  <head>
    <title>Título da página</title>
    <meta charset="utf-8">
  </head>
  <body>
    {% block content %}
        <h1>perguntas do simulado: {{simulado.titulo}} </h1>
        <ul>
                {% csrf_token %}
                {% for pergunta in perguntas %}
                    <li>{{ pergunta.texto }}</li>
                    {% for alternativa in alternativas %}
                        {% if alternativa.pergunta_id == pergunta.id %}
                            <input type="radio" name="{{pergunta.id}}" value="{{alternativa.id}}">{{alternativa.texto}}
                        {% endif %}
                    {% endfor %}
            {% empty %}
                <li>nao ha perguntas nesse simulado.</li>
            {% endfor %}
            <p></p>
        </ul>
          <form action="{% url 'simula_ai:resultado' %}" method="post">
            <input type="submit" value="resultado">
    {% endblock %}
  </body>
</html>

mysite/simula_ai/templates/simula_ai/index.html
<!DOCTYPE html>
{% load static %}

<html lang="pt-br">
  <head>
    <title>Título da página</title>
    <meta charset="utf-8">
  </head>
  <body>
    <h2>simulados cadastrados:</h2>
    {% block content %}
        {%for simulado in simulados%}
            <ul>
                <li><a href="{% url 'simula_ai:detalhes' simulado.id %}">{{simulado.titulo}}</a></li>
            </ul>
        {%endfor%}
    {% endblock %}
  </body>
</html>

mysite/simula_ai/templates/simula_ai/resultado.html
<!DOCTYPE html>
{% load static %}

<html lang="pt-br">
  <head>
    <title>Título da página</title>
    <meta charset="utf-8">
  </head>
  <body>
    {% block content %}
        <h1>perguntas do simulado: {{simulado.titulo}} </h1>
        <ul>
                {% for pergunta in perguntas %}
                    <li>{{ pergunta.texto }}</li>
                    {% for alternativa in alternativas %}
                        {% if alternativa.pergunta_id == pergunta.id and alternativa.correta == True %}
                            <ul>{{alternativa.texto}}</ul>
                        {% endif %}
                    {% endfor %}
            {% empty %}
                <li>nao ha perguntas nesse simulado.</li>
            {% endfor %}
            <p></p>
        </ul>
        
    {% endblock %}
  </body>
</html>